package ru.dbotthepony.kstarbound.util

import java.io.OutputStream
import java.nio.ByteBuffer
import java.nio.ByteOrder

class ByteBufferOutputStream(val buffer: ByteBuffer) : OutputStream() {
	override fun write(b: Int) {
		buffer.put(b.toByte())
	}

	override fun write(b: ByteArray) {
		buffer.put(b)
	}

	override fun write(b: ByteArray, off: Int, len: Int) {
		buffer.put(b, off, len)
	}

	var position: Int
		get() = buffer.position()
		set(value) { buffer.position(value) }

	companion object {
		fun directLE(capacity: Int) = ByteBufferOutputStream(ByteBuffer.allocateDirect(capacity).also { it.order(ByteOrder.LITTLE_ENDIAN) })
	}
}
